<?php

if (!isset($userdata)) die();
if (!mod_checkTableID('datasets', $cid)) $cid = 0;

if ($cid == 0 || ($index == 'data' && $subindex == ''))
{
	$edit = new sqledit;
	$edit->sqltablename = 'datasets';
	$edit->adddefaults['user_id'] = $userdata['id'];
	$edit->sqlwhere = '';
	$edit->sortable = false;
	$edit->savedelete = true;
	$edit->relations['name'] = array('name' => 'Dataset', 'force' => true, 'sql' => 'CONCAT("<a href=\'' . mysql_escape_string($modules_defaults['defaultlink']) . '&setcid=", datasets.id, "\'>", name, "</a>")');
	$edit->relations['user'] = array('name' => 'Owner', 'type' => 'virtual', 'sql' => 'user.username');
	$edit->sqljoin = 'LEFT JOIN user ON user.id = user_id';
	CreateSqlEdit($edit);
	unset($edit);
	echo '<hr>';
}

if ($cid != 0)
{
	$query = "SELECT user_id FROM datasets WHERE id = $cid";
	if (mysql_result(mod_mysql_querya($query), 0) != $userdata['id']) $cid = 0;

	$name = mod_getTableNameFromId('datasets', $cid);
	echo '<center><font style="font-size:26px;">Dataset: ' . $name . '</font></center>';

	if ($subindex == '')
	{
		echo '<br><br>';
		CreateSubMenu($menu, 'Edit', true);
	}
	echo '<hr></center><br>';

	if ($subindex != '')
	{
		$edit = new sqledit;
		$edit->sqltablename = 'd_' . $subindex;
		$edit->sortable = false;
		$edit->tabledata['repeatHeader'] = 35;
		$edit->tabledata['numerize'] = true;
		$edit->tabledata['search'] = array(1);
		$edit->adddefaults['dataset_id'] = $cid;
		$edit->sqlwhere = '';
	}

	switch($subindex)
	{
		case 'import':
			echo "<center><font style='font-size:26px;'>Import Utility</font><br>
				<font style='color:red;'>Warning: This will override the old dataset!</font><br><br>";
			$name = 'Start';

			if (isset($_GET['doimport']) && $_GET['doimport'])
			{
				echo '<table><tr><td>';
				require 'import.php';
				echo '</td></tr></table>';
				echo "Import Successfull<br><br>";
				$name = 'Restart';
			}

			echo "<a href='$modules_defaults[defaultlink]&doimport=1'>$name</a></center>";
			break;

		case 'export':
			echo "<center><font style='font-size:26px;'>Export Utility</font><br>";
			$name = 'Start';

			if (isset($_GET['doexport']) && $_GET['doexport'])
			{
				echo '<table><tr><td>';
				require 'export.php';
				echo '</td></tr></table>';
				echo "Export Successfull<br><br>";
				$name = 'Restart';
			}

			echo "<a href='$modules_defaults[defaultlink]&doexport=1'>$name</a></center>";
			break;

		case 'cleanup':
			if (mod_user_defaultcallback('root') !== true) break;
			echo "<center><font style='font-size:26px;'>Cleanup Utility</font><br>
				<font style='color:red;'>Warning: This will delete all datasets!!!!</font><br><br>";
			$name = 'Start';

			if (isset($_GET['doclean']) && $_GET['doclean'])
			{
				echo '<table><tr><td>';

				$query = "SHOW TABLES";
				$result = mod_mysql_querya($query);
				while ($tmp = mysql_fetch_row($result))
				{
					if (strpos($tmp[0], 'd_') === 0 || strpos($tmp[0], 'char_') === 0 || $tmp[0] == 'characters')
					{
						$query = "TRUNCATE TABLE `" . mysql_escape_string($tmp[0]) . "`";
						mod_mysql_querya($query);
					}
				}

				echo '</td></tr></table>';
				echo "Cleanup Successfull<br><br>";
				$name = 'Restart';
			}

			echo "<a href='$modules_defaults[defaultlink]&doclean=1'>$name</a></center>";
			break;

		case 'abbilities':
			$edit->title = 'Abbilities';
			$edit->name = 'Abbility';
			$edit->relations = array(
				'name' => array('name' => 'Abbility', 'force' => true, 'nodual' => true),
				'text' => array('name' => 'Text', 'rows' => 3, 'cut' => 150),
				'script' => array('name' => 'Script', 'rows' => 10, 'hide' => true)
			);
			break;

		case 'boni':
			$edit->title = 'Boni';
			$edit->name = 'Bonus';
			$edit->relations = array(
				'name' => array('name' => 'Bonus', 'force' => true, 'nodual' => true),
				'stack' => array('name' => 'Stackable', 'type' => 'checkbox')
			);
			break;

		case 'characters':
			$edit->title = 'Characters';
			$edit->name = 'character';
			$edit->relations = array(
				'name' => array('name' => 'Class', 'force' => true, 'nodual' => true),
				'tw' => array('name' => 'Hit Dice'),
				'st' => array('name' => 'Strength', 'type' => 'int', 'force' => true, 'hide' => true),
				'ge' => array('name' => 'Dexterity', 'type' => 'int', 'force' => true, 'hide' => true),
				'ko' => array('name' => 'Constitution', 'type' => 'int', 'force' => true, 'hide' => true),
				'in' => array('name' => 'Intelligence', 'type' => 'int', 'force' => true, 'hide' => true),
				'we' => array('name' => 'Wisdom', 'type' => 'int', 'force' => true, 'hide' => true),
				'ch' => array('name' => 'Charisma', 'type' => 'int', 'force' => true, 'hide' => true),
				'probability' => array('name' => 'Probability', 'type' => 'int', 'force' => true),
				'gatype' => array('name' => 'Base Attack Bonus', 'type' => 'select', 'options' => $BaseAttackOptions),
				'ref' => array('name' => 'Reflex Save', 'type' => 'select', 'options' => $SaveOptions, 'hide' => true),
				'wil' => array('name' => 'Will Save', 'type' => 'select', 'options' => $SaveOptions, 'hide' => true),
				'zh' => array('name' => 'Fortitude Save', 'type' => 'select', 'options' => $SaveOptions, 'hide' => true),
				'attack' => array('name' => 'Prefered Attack Type', 'type' => 'select', 'options' => array_merge(array(0 => 'Fist'), $AttackOptions), 'hide' => true),
				'skills' => array('name' => 'Skillpoints', 'formname' => 'Skillpoints / Level', 'type' => 'int', 'force' => true),
				'prest' => array('name' => 'Prest. Cl.', 'formname' => 'Prestige Class', 'type' => 'checkbox'),
				'maxlvl' => array('name' => 'Max. Level', 'type' => 'int', 'force' => 1),
				'effectscript' => array('name' => 'Script', 'rows' => 10, 'hide' => true, 'default' => ';'),
				'spelltype' => array('name' => 'Spelltype (Number of Spells)', 'type' => 'select', 'options' => $SpellTypeOptions, 'hide' => true),
				'increasespelltype' => array('name' => 'Continue Spell Class', 'type' => 'checkbox', 'hide' => true),
				'spontancast' => array('name' => 'Spontan Casting', 'type' => 'select', 'options' => $SpontanCastTypes, 'hide' => true),
				'domains' => array('name' => 'Domains', 'type' => 'int', 'force' => 1, 'hide' => true),
				'specialize' => array('name' => 'School Specialization', 'type' => 'select', 'options' => $SpecializeOptions, 'hide' => true),
				'powertype' => array('name' => 'PSI Power Type', 'type' => 'select', 'options' => $PSIPowerOptions, 'hide' => true),
				'req' => array('name' => 'Requirements', 'force' => true, 'hide' => true, 'default' => ';'),
				'skillreq' => array('name' => 'Skill Requirements', 'force' => true, 'hide' => true, 'default' => ';'),
				'featreq' => array('name' => 'Feat Requirements', 'force' => true, 'hide' => true, 'default' => ';'),
				'givefeats' => array('name' => 'Class Feats', 'rows' => 3, 'force' => true, 'hide' => true, 'default' => ';'),
				'bonusfeats' => array('name' => 'Bonus Feats', 'force' => true, 'hide' => true, 'default' => ';'),
				'bonusfeattype' => array('name' => 'Bonus Feat Type', 'type' => 'select', 'options' => $FeatTypeOptions, 'hide' => true),
				'epicfeats' => array('name' => 'Epic Feats', 'type' => 'int', 'force' => true, 'hide' => true),
				'spellfailure' => array('name' => 'Spell Failure', 'type' => 'checkbox', 'hide' => true),
				'effects' => array('name' => 'Use Effects', 'type' => 'list', 'binarylist' => true, 'hide' => true, 'listdata' =>
					"SELECT types.id, types.name, IF(d_characters.id IS NULL, 0, 1) AS sel FROM ((SELECT 1 AS id, 'Fighter' AS name) UNION (SELECT 2 AS id, 'Magic' AS name) UNION (SELECT 4 AS id, 'Shadow' AS name) UNION (SELECT 8 AS id, 'Divine' AS name)) AS types LEFT JOIN d_characters ON d_characters.id = [ID] AND (d_characters.effects & types.id) = types.id"
				),
				'attachclass' => array('name' => 'Must Attach Class', 'type' => 'select', 'options' => "(SELECT 0 AS id, 'Keine' AS name) UNION (SELECT id, name FROM d_characters WHERE dataset_id = $cid)", 'hide' => true),
				'noeq' => array('name' => 'Limited equipment', 'type' => 'select', 'options' => $LimitEquipOptions, 'hide' => true),
				'psidisc' => array('name' => 'Psionic Disciples', 'type' => 'checkbox', 'hide' => true),
				'psicrys' => array('name' => 'Psi Crystal', 'type' => 'checkbox', 'hide' => true),
				'forceattack' => array('name' => 'Force Attack Type', 'type' => 'select', 'options' => array_merge(array(0 => '-'), $AttackOptions), 'hide' => true),
				'forceweapontype' => array('name' => 'Force Weapon Type', 'type' => 'select', 'options' => array_merge(array(0 => '-'), $WeaponTypeOptions), 'hide' => true),
				'forceweapon' => array('name' => 'Force Weapon', 'type' => 'select', 'options' => "(SELECT 0 AS id, '-' AS name) UNION (SELECT id, name FROM d_equipment WHERE dataset_id = $cid)", 'hide' => true),
				'naturalenhence' => array('name' => 'Natural Weapon Enhencement', 'type' => 'checkbox', 'hide' => true),
				'derrive' => array('name' => 'Derrive Feat Probability', 'type' => 'select', 'options' => "(SELECT 0 AS id, '-' AS name) UNION (SELECT id, name FROM d_characters WHERE dataset_id = $cid)", 'hide' => true),
				'copyspells' => array('name' => 'Copy Spell List', 'type' => 'select', 'options' => "(SELECT ';' AS id, '-' AS name) UNION (SELECT name AS id, name FROM d_characters WHERE dataset_id = $cid)", 'hide' => true),
				'npc' => array('name' => 'NPC', 'type' => 'checkbox'),
				'spellattr' => array('name' => 'Spell Attribute', 'type' => 'select', 'options' => array_merge(array(-1 => '-'), $AttributeOptions), 'hide' => true),
				'bonusclassskills' => array('name' => 'Bonus Class Skills', 'type' => 'int', 'force' => 1, 'hide' => true),
				'spelltype2' => array('name' => 'Spell Type', 'type' => 'select', 'options' => $MagicTypeOptions, 'hide' => true),
				'nometal' => array('name' => 'No Metal', 'type' => 'checkbox', 'hide' => true)
			);
			break;

		case 'domains':
			$edit->title = 'Domains';
			$edit->name = 'Domain';
			$edit->relations = array('name' => array('name' => 'Domain', 'force' => true, 'nodual' => true));
			break;

		case 'effects':
			$edit->title = 'Effects';
			$edit->name = 'Effect';
			$edit->relations = array(
				'effect' => array('name' => 'Effect', 'force' => true, 'nodual' => true),
				'weapon' => array('name' => 'Weapon Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'armor' => array('name' => 'Armor Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'shield' => array('name' => 'Shield Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'helmet' => array('name' => 'Helmet Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'ring' => array('name' => 'Ring Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'amulet' => array('name' => 'Amulet Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'gloves' => array('name' => 'Glove Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'boots' => array('name' => 'Boots Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'belt' => array('name' => 'Belt Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'cloak' => array('name' => 'Cloak Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'westment' => array('name' => 'Westment Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'fight' => array('name' => 'Fighter Class Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'mage' => array('name' => 'Magic Class Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'shadow' => array('name' => 'Rogue/Shadow Class Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'cleric' => array('name' => 'Divine Class Probability', 'type' => 'int', 'force' => 1, 'hide' => true),
				'multi' => array('name' => 'Multiple Times', 'type' => 'select', 'options' => $EffectMultiOptions, 'hide' => true),
				'cost' => array('name' => 'Enchantment', 'type' => 'int', 'force' => 1, 'default' => 1),
				'cost2' => array('name' => 'Min. Price', 'type' => 'int', 'force' => true),
				'effectscript' => array('name' => 'Script', 'rows' => 10, 'hide' => 'true', 'default' => ';', 'hide' => true),
				'skillboost' => array('name' => 'Skillboost', 'hide' => true, 'default' => ';'),
				'variable' => array('name' => 'Variable Price/Power', 'rows' => 3, 'default' => ';', 'hide' => true),
				'ranged' => array('name' => 'Ranged', 'type' => 'select', 'options' => $RangedOptions, 'hide' => true)
			);
			break;

		case 'equipment':
			$edit->title = 'Equipment';
			$edit->name = 'Item';
			$edit->relations = array(
				'name' => array('name' => 'Name', 'force' => true, 'nodual' => true),
				'damage1' => array('name' => 'Damage 1', 'type' => 'int', 'force' => true, 'sql' => 'CONCAT(damage1, "W", damage2)'),
				'damage2' => array('name' => 'Damage 2', 'type' => 'int', 'force' => true, 'hide' => true),
				'size' => array('name' => 'Size', 'type' => 'select', 'options' => $SizeRelOptions),
				'critical' => array('name' => 'Critical Hit', 'type' => 'int', 'force' => 1, 'appendform' => ' - 20'),
				'criticalm' => array('name' => 'Critical Multiplier', 'type' => 'int', 'force' => 1),
				'attacktype' => array('name' => 'Attack Type', 'type' => 'select', 'options' => $AttackOptions),
				'type' => array('name' => 'Type', 'type' => 'select', 'options' => $EquipSubTypeOptions, 'sql' =>
					'IF(equiptype=0,CASE type WHEN 0 THEN "Einfache Waffe" WHEN 1 THEN "Kriegswaffe" WHEN 2 THEN "Exotische Waffe" END, IF(equiptype=1, CASE type WHEN 0 THEN "Leichte Rstung" WHEN 1 THEN "Mittelschwere Rstung" WHEN 2 THEN "Schwere Rstung" END, ""))'),
				'equiptype' => array('name' => 'Equipment Type', 'type' => 'select', 'options' => $EquipTypeOptions),
				'prob' => array('name' => 'Probability', 'type' => 'int', 'force' => 1),
				'armor' => array('name' => 'AC', 'type' => 'int', 'force' => 1),
				'maxdex' => array('name' => 'Max. Dex,', 'type' => 'int', 'force' => 1),
				'malus' => array('name' => 'Armor Malus', 'type' => 'int', 'force' => 1),
				'spellf' => array('name' => 'Spell Failure', 'type' => 'int', 'force' => 1),
				'metal' => array('name' => 'Matalic', 'type' => 'checkbox'),
				'minlevel' => array('name' => 'Min. Char. Level', 'type' => 'int', 'force' => 1),
				'rare' => array('name' => 'Divede Probability', 'type' => 'int', 'force' => 1),
				'script' => array('name' => 'Script', 'rows' => 3, 'default' => ';', 'hide' => true),
				'forbiteffects' => array('name' => 'Forbit Additional Effects', 'type' => 'checkbox', 'hide' => true),
				'amount' => array('name' => 'Maximum Amount of Treasure', 'type' => 'int', 'force' => 1, 'hide' => true)
			);
			break;

		case 'feats':
			$query = "SELECT name FROM d_characters WHERE derrive = 0 AND dataset_id = $cid";
			$charstmp = mod_Query2Array($query, false, 0);
			$chars = array();
			foreach ($charstmp AS $char)
			{
				$chars[strtolower($char)] = array('name' => $char . ' Probability', 'type' => 'int', 'force' => 1, 'hide' => true);
			}

			$edit->title = 'Feats';
			$edit->name = 'Feat';
			$edit->relations = array_merge(
				array('name' => array('name' => 'Feat', 'force' => true, 'nodual' => true)),
				$chars,
				array(
					'multi' => array('name' => 'Multiple times', 'type' => 'select', 'options' => $FeatMultiOptions, 'hide' => true),
					'epic' => array('name' => 'Epic', 'type' => 'checkbox'),
					'req' => array('name' => 'Requirements', 'force' => true, 'default' => ';', 'hide' => true),
					'skillreq' => array('name' => 'Skill Requirements', 'force' => true, 'default' => ';', 'hide' => true),
					'dep' => array('name' => 'Dependancy', 'type' => 'select', 'options' => $FeatDepOptions),
					'effectscript' => array('name' => 'Script', 'rows' => 5, 'default' => ';', 'hide' => true),
					'attackdep' => array('name' => 'Attack Type Requirements', 'type' => 'select', 'options' => $FeatAttackOptions, 'hide' => true),
					'feattype' => array('name' => 'Feat Type', 'type' => 'select', 'options' => $FeatTypeOptions),
					'text' => array('name' => 'Text', 'rows' => 3, 'hide' => true, 'default' => ';'),
					'inborn' => array('name' => 'Inborn', 'type' => 'checkbox'),
					'rel' => array('name' => 'Region', 'force' => true, 'default' => 0, 'hide' => true),
					'standard' => array('name' => 'Standard Feat', 'formname' => 'Standard Feat (Player / Master Book)', 'type' => 'checkbox'),
					'exclusive' => array('name' => 'Exclusive Feat', 'type' => 'checkbox')
				)
			);
			break;

		case 'monsters':
			$query = "SELECT id, name FROM d_feats WHERE dataset_id = $cid";
			$featopts = mod_createselectoptions($query);

			$query = "SELECT id, name FROM d_skills WHERE dataset_id = $cid";
			$skillopts = mod_createselectoptions($query);

			$edit->title = 'Monsters';
			$edit->name = 'Monster';
			$edit->relations = array(
				'name' => array('name' => 'Monster', 'force' => true),
				'cr' => array('name' => 'CR', 'type' => 'int', 'signed' => true, 'force' => 1),
				'type' => array('name' => 'Type', 'type' => 'select', 'options' => "SELECT id, name FROM d_monstertypes WHERE dataset_id = $cid"),
				'size' => array('name' => 'Size', 'type' => 'select', 'options' => "SELECT id, name FROM d_size WHERE dataset_id = $cid"),
				'epic' => array('name' => 'Epic', 'type' => 'checkbox'),
				'hd' => array('name' => 'HP', 'formname' => 'HD', 'type' => 'int', 'force' => true, 'sql' => 'CONCAT(hd, "W", hdt, "+", tp)'),
				'hdt' => array('name' => 'HD Type', 'type' => 'int', 'force' => true, 'hide' => true),
				'tp' => array('name' => 'HP', 'type' => 'int', 'force' => 1, 'hide' => true),
				'ref' => array('name' => 'Reflex Save', 'type' => 'int', 'force' => 1),
				'wil' => array('name' => 'Will Save', 'type' => 'int', 'force' => 1),
				'zaeh' => array('name' => 'Fortitude Save', 'type' => 'int', 'force' => 1),
				'st' => array('name' => 'Strength', 'type' => 'int', 'force' => 1),
				'ge' => array('name' => 'Dexterity', 'type' => 'int', 'force' => 1),
				'ko' => array('name' => 'Constitution', 'type' => 'int', 'force' => 1),
				'in' => array('name' => 'Intelligence', 'type' => 'int', 'force' => 1),
				'we' => array('name' => 'Wisdom', 'type' => 'int', 'force' => 1),
				'ch' => array('name' => 'Charisma', 'type' => 'int', 'force' => 1),
				'ac' => array('name' => 'AC', 'type' => 'int', 'force' => true),
				'hdmin' => array('name' => 'Minimum HD', 'type' => 'int', 'force' => 1, 'hide' => true),
				'hdmax' => array('name' => 'Maximum HD', 'type' => 'int', 'force' => 1, 'hide' => true),
				'hdinc' => array('name' => 'First Size increase at', 'appendform' => ' HD', 'type' => 'int', 'force' => 1, 'hide' => true),
				'hdinc2' => array('name' => 'Second Size increase at', 'appendform' => ' HD', 'type' => 'int', 'force' => 1, 'hide' => true),
				'init' => array('name' => 'Initiative', 'type' => 'int', 'force' => 1),
				'speed' => array('name' => 'Speed', 'type' => 'int', 'force' => 1),
				'orgmin' => array('name' => 'Min. Amount', 'type' => 'int', 'force' => true, 'hide' => true),
				'orgmax' => array('name' => 'Max. Amount', 'type' => 'int', 'force' => true, 'hide' => true),
				'mixed' => array('name' => 'Attitute to mix with other Monsters', 'type' => 'int', 'force' => 1, 'hide' => true),
				'treasur' => array('name' => 'Treasure Multiplier', 'type' => 'int', 'force' => 1, 'hide' => true),
				'spellchar' => array('name' => 'Spellchar', 'force' => true, 'default' => ';', 'hide' => true),
				'clericspells' => array('name' => 'Cleric as arcane spells', 'type' => 'checkbox', 'hide' => true),
				'familiar' => array('name' => 'Familiar Script', 'rows' => 3, 'default' => ';', 'hide' => true),
				'abbilities' => array('name' => 'Abbilities', 'force' => true, 'hide' => true, 'default' => ';'),
				'attacks' => array('name' => 'Attacks', 'type' => 'multi', 'sqllink' => 'd_monster_attacks', 'sql' => 'COUNT(DISTINCT d_monster_attacks.id)',
					'sqllinkdata' => array('monsters_id' => '[ID]', 'attack' => '[LINK0]', 'number' => '[LINK1]',
						'attred' => '[LINK2]', 'dmga' => '[LINK3]', 'dmgb' => '[LINK4]', 'dmgc' => '[LINK5]',
						'type' => '[LINK6]', 'altern' => '[LINK7]'),
					'multilink' => true, 'multitexthtml' => '<table width=100%>
						<tr><td>Anzahl Angriffe</td><td><input name="[NAME][1]" style="width:100%;"></td><td>Angriffsart</td><td><input name="[NAME][6]"></td></tr>
						<tr><td>Angriffsbonus</td><td><input name="[NAME][0]" style="width:100%;"></td><td>Je weiterer Angriff -</td><td><input name="[NAME][2]" style="width:100%;"></tr>
						<tr><td>Schaden</td><td colspan=3><input name="[NAME][3]" size=1> W<input name="[NAME][4]" size=1> + <input name="[NAME][5]" size=1></td></tr>
						<tr><td>Angriffsgruppe</td><td colspan=3><input name="[NAME][7]"></td></tr>
						</table>', 'sqllinknums' => 'num'),
				'feats' => array('name' => 'Feats', 'type' => 'multi', 'sqllink' => 'd_monster_feats', 'sql' => 'COUNT(DISTINCT d_monster_feats.id)',
					'sqllinkdata' => array('monsters_id' => '[ID]', 'feat' => '[LINK]'), 'multitexthtml' => '<select name="[NAME]">' . $featopts . '</select>',
					'multitextselects' => 1, 'sqllinknums' => 'num'),
				'skills' => array('name' => 'Skills', 'type' => 'multi', 'sqllink' => 'd_monster_skills', 'sql' => 'COUNT(DISTINCT d_monster_skills.id)',
					'sqllinkdata' => array('monsters_id' => '[ID]', 'skill' => '[LINK0]', 'skilll' => '[LINK1]'), 'multilink' => true,
					'multitexthtml' => '<select name="[NAME][0]">' . $skillopts . '</select> - Level <input name="[NAME][1]">',
					'multitextselects' => array(0), 'sqllinknums' => 'num')
			);
			$edit->sqljoin = 'LEFT JOIN d_monster_attacks ON d_monsters.id = d_monster_attacks.monsters_id
						LEFT JOIN d_monster_feats ON d_monsters.id = d_monster_feats.monsters_id
						LEFT JOIN d_monster_skills ON d_monsters.id = d_monster_skills.monsters_id';
			$edit->tabledata['search'] = array_merge($edit->tabledata['search'], array('Type'));
			break;

		case 'monstertypes':
			$edit->title = 'Monster Types';
			$edit->name = 'Monstertype';
			$edit->relations = array(
				'name' => array('name' => 'Monstertype', 'force' => true, 'nodual' => true),
				'ga' => array('name' => 'Base Attack Bonus', 'type' => 'select', 'options' => $BaseAttackOptions),
				'rwref' => array('name' => 'Reflex Save', 'type' => 'select', 'options' => $SaveOptions),
				'rwwil' => array('name' => 'Will Save', 'type' => 'select', 'options' => $SaveOptions),
				'rwzaeh' => array('name' => 'Fortitude Save', 'type' => 'select', 'options' => $SaveOptions),
				'mixed' => array('name' => 'Mixed Char possible', 'type' => 'checkbox'),
				'mixedeq' => array('name' => 'Equipment possible', 'type' => 'checkbox'),
				'skills' => array('name' => 'Skillpoints', 'type' => 'int', 'force' => 1),
				'feats' => array('name' => 'Feats (every n level)', 'type' => 'int', 'force' => 1)
			);
			break;

		case 'powers':
			$edit->title = 'Psionic Powers';
			$edit->name = 'Power';
			$edit->relations = array(
				'name' => array('name' => 'Power', 'force' => true, 'nodual' => true),
				'psion' => array('name' => 'Level (Psion)', 'type' => 'int', 'signed' => true, 'force' => true),
				'psychicw' => array('name' => 'Level (Psychic Warrior)', 'type' => 'int', 'signed' => true, 'force' => true),
				'attribute' => array('name' => 'Attribute', 'type' => 'select', 'options' => $AttributeOptions)
			);
			break;

		case 'races':
			$edit->title = 'Races';
			$edit->name = 'Race';
			$edit->relations = array(
				'name' => array('name' => 'Race', 'force' => true, 'nodual' => true),
				'prob' => array('name' => 'Probability', 'type' => 'int', 'force' => true),
				'size' => array('name' => 'Size', 'type' => 'select', 'options' => $SizeRelOptions),
				'attacktype' => array('name' => 'Prefered Attack Type', 'type' => 'select', 'options' => $AttackOptions),
				'racemod' => array('name' => 'Attr. Mod.', 'force' => true, 'default' => '0;0;0;0;0;0'),
				'effectscript' => array('name' => 'Script', 'rows' => 5, 'default' => ';', 'hide' => true),
				'range' => array('name' => 'Range (meter)', 'type' => 'int', 'force' => true),
				'subrace' => array('name' => 'Subrace', 'type' => 'select', 'options' => "(SELECT 0 AS id, ';' AS name) UNION (SELECT id, name FROM d_races WHERE dataset_id = $cid)"),
				'hgmod' => array('name' => 'CR Mod.', 'type' => 'int', 'force' => 1),
				'givefeats' => array('name' => 'Race Feats', 'rows' => 5, 'default' => ';', 'hide' => true)
			);
			break;

		case 'regions':
			$edit->title = 'Regions';
			$edit->name = 'Region';
			$edit->relations = array(
				'name' => array('name' => 'Region', 'force' => true, 'nodual' => true)
			);
			break;

		case 'schools':
			$edit->title = 'Schools';
			$edit->name = 'School';
			$edit->relations = array(
				'name' => array('name' => 'School', 'force' => true, 'nodual' => true)
			);
			break;

		case 'size':
			$edit->title = 'Sizes';
			$edit->name = 'Size';
			$edit->relations = array(
				'name' => array('name' => 'Size', 'force' => true, 'nodual' => true),
				'st' => array('name' => 'Strength', 'type' => 'int', 'signed' => true, 'force' => true),
				'ge' => array('name' => 'Dexterity', 'type' => 'int', 'signed' => true, 'force' => true),
				'ko' => array('name' => 'Constitution', 'type' => 'int', 'signed' => true, 'force' => true),
				'ac' => array('name' => 'AC', 'type' => 'int', 'signed' => true, 'force' => true),
				'sizemod' => array('name' => 'Modifikator', 'type' => 'int', 'signed' => true, 'force' => true)
			);
			break;

		case 'skills':
			$query = "DESCRIBE d_skills";
			$fields = mod_Query2Array($query, false, 'Field');

			$query = "SELECT id, name FROM d_characters WHERE dataset_id = $cid";
			$result = mod_mysql_querya($query);
			$skillrelations = array();
			while ($tmp = mysql_fetch_assoc($result))
			{
				if (in_array(strtolower($tmp['name']), $fields))
				{
					$skillrelations[strtolower($tmp['name'])] = array('name' => $tmp['name'], 'type' => 'int', 'force' => 1, 'hide' => true);
				}
			}

			$edit->title = 'Skills';
			$edit->name = 'Skill';
			$edit->relations = array(
				'name' => array('name' => 'Skill', 'force' => true, 'nodual' => true),
				'attr' => array('name' => 'Attribute', 'type' => 'select', 'options' => $AttributeOptions),
				'untrained' => array('name' => 'Untrained', 'type' => 'checkbox'),
				'armormalus' => array('name' => 'Armor Malus', 'type' => 'int', 'force' => 1),
				'synergy' => array('name' => 'Synergy', 'default' => ';', 'hide' => true, 'force' => true)
			);
			$edit->relations = array_merge($edit->relations, $skillrelations);
			break;

		case 'specials':
			$edit->title = 'Specials';
			$edit->name = 'Special';
			$edit->relations = array(
				'name' => array('name' => 'Special', 'force' => true, 'nodual' => true),
				'type' => array('name' => 'Type', 'type' => 'select', 'options' => $SpecialOptions),
				'spelllevel' => array('name' => 'Spell Level', 'type' => 'int', 'force' => 1),
				'script' => array('name' => 'Script', 'rows' => 5, 'default' => ';', 'force' => true, 'hide' => true)
			);
			break;

		case 'specific':
			$edit->title = 'Specific';
			$edit->name = 'Specific';
			$edit->relations = array(
				'name' => array('name' => 'Specific', 'force' => true, 'nodual' => true),
				'on' => array('name' => 'On', 'type' => 'select', 'options' => "SELECT id, name FROM d_equipment WHERE dataset_id = $cid"),
				'price' => array('name' => 'Price', 'type' => 'int', 'force' => 1),
				'fight' => array('name' => 'Fighter Prob', 'type' => 'int', 'force' => 1),
				'mage' => array('name' => 'Mage Prob', 'type' => 'int', 'force' => 1),
				'shadow' => array('name' => 'Thief/Bard Prob', 'type' => 'int', 'force' => 1),
				'divine' => array('name' => 'Divine Prob', 'type' => 'int', 'force' => 1),
				'script' => array('name' => 'Script', 'rows' => 5, 'default' => ';', 'force' => true, 'hide' => true),
				'skillboost' => array('name' => 'Skillboost', 'default' => ';', 'force' => true, 'hide' => true)
			);
			break;

		case 'spells':
			$edit->title = 'General Spell List';
			$edit->name = 'Spell';
			$edit->relations = array(
				'name' => array('name' => 'Spell', 'force' => true, 'nodual' => true),
				'magier' => array('name' => 'Level (Wizard)', 'type' => 'int', 'signed' => true, 'force' => true, 'sql' => 'IF(magier=-1,"-",magier)'),
				'kleriker' => array('name' => 'Level (Cleric)', 'type' => 'int',  'signed' => true, 'force' => true, 'sql' => 'IF(kleriker=-1,"-",kleriker)'),
				'druide' => array('name' => 'Level (Druid)', 'type' => 'int',  'signed' => true, 'force' => true, 'sql' => 'IF(druide=-1,"-",druide)'),
				'barde' => array('name' => 'Level (Barde)', 'type' => 'int',  'signed' => true, 'force' => true, 'sql' => 'IF(barde=-1,"-",barde)'),
				'paladin' => array('name' => 'Level (Paladin)', 'type' => 'int',  'signed' => true, 'force' => true, 'sql' => 'IF(paladin=-1,"-",paladin)'),
				'waldlufer' => array('name' => 'Level (Ranger)', 'type' => 'int',  'signed' => true, 'force' => true, 'sql' => 'IF(waldlufer=-1,"-",waldlufer)'),
				'schule' => array('name' => 'School', 'type' => 'select', 'options' => "SELECT id, name FROM d_schools WHERE dataset_id = $cid"),
				'domne' => array('name' => 'Domain 1', 'type' => 'select', 'options' => "(SELECT 0 AS id, '-' AS name) UNION (SELECT id, name FROM d_domains WHERE dataset_id = $cid)"),
				'domne2' => array('name' => 'Domain 2', 'type' => 'select', 'options' => "(SELECT 0 AS id, '-' AS name) UNION (SELECT id, name FROM d_domains WHERE dataset_id = $cid)"),
				'probability' => array('name' => 'Probability', 'type' => 'int', 'force' => 1),
				'convert' => array('name' => 'Convertable by Cleric', 'type' => 'checkbox')
			);
			$edit->tabledata['search'] = array_merge($edit->tabledata['search'], array('School', 'Domain 1', 'Domain 2'));
			break;

		case 'spells2':
			$edit->title = 'Additional Spell Asignments';
			$edit->name = 'Class';
			$edit->relations['name'] = array('name' => 'Class', 'type' => 'select', 'options' => "SELECT id, name FROM d_characters WHERE dataset_id = $cid", 'nodual' => true);
			for ($i = 0;$i <= 9;$i++)
			{
				$edit->relations[$i] = array('name' => "Spells Lvl $i", 'default' => ';', 'hide' => true, 'force' => true);
			}
			break;

		case 'templates':
			$edit->title = 'Templates';
			$edit->name = 'Template';
			$edit->relations = array(
				'name' => array('name' => 'Template', 'force' => true, 'nodual' => true),
				'crscript' => array('name' => 'CR Script', 'force' => true, 'rows' => 3, 'default' => ';', 'hide' => true),
				'mixed' => array('name' => 'Mixed Char Possible', 'type' => 'checkbox'),
				'forcetype' => array('name' => 'Force Monster Type', 'force' => true, 'default' => ';', 'hide' => true),
				'forbittype' => array('name' => 'Forbid Monster Type', 'force' => true, 'default' => ';', 'hide' => true),
				'script' => array('name' => 'Script', 'rows' => 5, 'default' => ';', 'force' => true, 'hide' => true),
				'attrmod' => array('name' => 'Attr. Mod.', 'default' => '0;0;0;0;0;0', 'force' => true),
				'newtype' => array('name' => 'New Monster Type', 'default' => ';', 'force' => true)
			);
			break;

		case 'weapons':
			$query = 'DESCRIBE d_weapons';
			$fields = mod_Query2Array($query, false, 'Field');

			$weaponprob = array();
			$query = "(SELECT name FROM d_characters WHERE dataset_id = $cid) UNION (SELECT name FROM d_races WHERE dataset_id = $cid)";
			$result = mod_mysql_querya($query);
			while ($tmp = mysql_fetch_assoc($result))
			{
				if (in_array(strtolower($tmp['name']), $fields))
				{
					$weaponprob[strtolower($tmp['name'])] = array('name' => $tmp['name'], 'type' => 'int', 'force' => 1, 'hide' => true);
				}
			}

			$edit->title = 'Weapon Probabilities';
			$edit->name = 'Weapon';
			$edit->relations = array(
				'name' => array('name' => 'Item', 'type' => 'select', 'options' => "SELECT id, name FROM d_equipment WHERE equiptype = 0 AND dataset_id = $cid", 'nodual' => true),
				'monster' => array('name' => 'Used by Monster', 'type' => 'checkbox'),
				'specialtype' => array('name' => 'Weapon Type', 'type' => 'select', 'options' => array_merge(array(0 => 'Standard Weapon'), $WeaponTypeOptions))
			);
			$edit->relations += $weaponprob;
			break;

		case 'startmoney':
			$edit->title = 'Character Startmoney';
			$edit->relations = array(
				'num' => array('name' => 'Level', 'type' => 'int', 'force' => true, 'nodual' => true),
				'startmoney' => array('name' => 'Startmoney', 'type' => 'int', 'force' => true)
			);
			break;

		case 'treasure':
			$edit->title = 'Treasure';
			$edit->relations = array(
				'num' => array('name' => 'CR', 'type' => 'int', 'force' => 1, 'nodual' => true),
				'treasure' => array('name' => 'Treasure', 'type' => 'int', 'force' => true)
			);
			break;

		case 'monstertext':
			$query = "SELECT name FROM d_monsters WHERE dataset_id = $cid";
			$result = mod_mysql_querya($query);
			$options = '';
			while ($tmp = mysql_fetch_assoc($result))
			{
				$options .= "<option value='$tmp[name]'>$tmp[name]</option>";
			}
			$namesel = '<select onClick="document.getElementById(\'monstertextname\').value = this.value;">' . $options . '</select>';

			$edit->title = 'Monster Descriptions';
			$edit->name = 'Text';
			$edit->relations = array(
				'name' => array('name' => 'Name', 'force' => true, 'nodual' => true, 'inhtml' => 'id="monstertextname"',
					'appendform' => $namesel),
				'text' => array('name' => 'Text', 'rows' => 10, 'cut' => 100)
			);
			break;

		case 'profiles':
			$classopts = mod_createselectoptions("SELECT id, name FROM d_characters WHERE dataset_id = $cid");
			$featopts = mod_createselectoptions("SELECT id, name FROM d_feats WHERE dataset_id = $cid ORDER BY id ASC", false, false, false);
			$skillopts = mod_createselectoptions("SELECT id, name FROM d_skills WHERE dataset_id = $cid");
			$spellopts = mod_createselectoptions("SELECT id, name FROM d_spells WHERE dataset_id = $cid");
			$effectopts = mod_createselectoptions("SELECT id, effect FROM d_effects WHERE dataset_id = $cid", false, false, 'effect');
			$specialopts = mod_createselectoptions("SELECT id, name FROM d_specials WHERE dataset_id = $cid");

			$edit->title = 'Profiles';
			$edit->name = 'Profile';
			$edit->relations = array(
				'name' => array('name' => 'Name', 'force' => true, 'nodual' => true),
				'classes' => array('name' => 'Classes', 'type' => 'multi', 'sqllink' => 'd_profiles_classes', 'multilink' => true,
					'sqllinkdata' => array('profile_id' => '[ID]', 'class_id' => '[LINK0]', 'level' => '[LINK1]'), 'sqllinknums' => 'num',
					'hide' => true, 'multitextselects' => array(0), 'multitexthtml' => "Class:<select name=\"[NAME][0]\">$classopts</select> - Levels:<input name=\"[NAME][1]\">"),
				'attack1' => array('name' => 'Primary Attack Type', 'type' => 'select', 'options' => array_merge(array(0 => 'Fist'), $AttackOptions)),
				'attack2' => array('name' => 'Secondary Attack Type', 'type' => 'select', 'options' => array_merge(array(0 => 'Fist'), $AttackOptions)),
				'weapon1_id' => array('name' => 'Weapon 1', 'type' => 'select', 'options' => "(SELECT 0 AS id, 'None' AS name) UNION (SELECT d_weapons.id, d_equipment.name FROM d_weapons LEFT JOIN d_equipment ON d_weapons.name = d_equipment.id WHERE d_weapons.dataset_id = $cid ORDER BY d_equipment.name ASC)"),
				'weapon2_id' => array('name' => 'Weapon 2', 'type' => 'select', 'options' => "(SELECT 0 AS id, 'None' AS name) UNION (SELECT d_weapons.id, d_equipment.name FROM d_weapons LEFT JOIN d_equipment ON d_weapons.name = d_equipment.id  WHERE d_weapons.dataset_id = $cid ORDER BY d_equipment.name ASC)"),
				'feats' => array('name' => 'Feats', 'type' => 'multi', 'sqllink' => 'd_profiles_links',
					'sqllinkdata' => array('profile_id' => '[ID]', 'link' => '[LINK]', 'type' => 'feat'), 'sqllinknums' => 'num',
					'hide' => true, 'multitextselects' => 1, 'multitexthtml' => "<select name=\"[NAME]\">$featopts</select>"),
				'skills' => array('name' => 'Skills', 'type' => 'multi', 'sqllink' => 'd_profiles_skills', 'multilink' => true,
					'sqllinkdata' => array('profile_id' => '[ID]', 'skill_id' => '[LINK0]', 'minlvl' => '[LINK1]', 'maxlvl' => '[LINK2]'), 'sqllinknums' => 'num',
					'hide' => true, 'multitextselects' => array(0), 'multitexthtml' => "Skill: <select name=\"[NAME][0]\">$skillopts</select> - Min. Lvl.:<input name=\"[NAME][1]\"> - Max. Lvl.: Min. Lvl.:<input name=\"[NAME][2]\">"),
				'armor_id' => array('name' => 'Armor', 'type' => 'select', 'options' => "(SELECT id, name FROM d_equipment WHERE dataset_id = $cid AND equiptype = 1 ORDER BY name ASC) UNION (SELECT 0 AS id, 'Armreif' AS name)"),
				'armortype' => array('name' => 'Armor Type', 'type' => 'select', 'options' => $ArmorTypeOptions),
				'shield_id' => array('name' => 'Shield', 'type' => 'select', 'options' => "(SELECT 0 AS id, 'None' AS name) UNION (SELECT id, name FROM d_equipment WHERE dataset_id = $cid AND equiptype = 2 ORDER BY name ASC)"),
				'shielduse1' => array('name' => 'Use shield with primary weapon', 'type' => 'checkbox', 'hide' => true),
				'shielduse2' => array('name' => 'Use shield with secondary weapon', 'type' => 'checkbox', 'hide' => true),
				'race_id' => array('name' => 'Race', 'type' => 'select', 'options' => "SELECT id, name FROM d_races WHERE dataset_id = $cid ORDER BY name ASC"),
				'minlvl' => array('name' => 'Min. Lvl.', 'type' => 'int', 'force' => true),
				'spells' => array('name' => 'Spells', 'type' => 'multi', 'sqllink' => 'd_profiles_spells', 'multilink' => true,
					'sqllinkdata' => array('profile_id' => '[ID]', 'spell_id' => '[LINK0]', 'amount' => '[LINK1]'), 'sqllinknums' => 'num',
					'hide' => true, 'multitextselects' => array(0), 'multitexthtml' => "Spell: <select name=\"[NAME][0]\">$spellopts</select> - Amount:<input name=\"[NAME][1]\">"),
				'school_id' => array('name' => 'Prefered School', 'type' => 'select', 'options' => "SELECT id, name FROM d_schools WHERE dataset_id = $cid ORDER BY name ASC"),
				'domain_id' => array('name' => 'Prefered School', 'type' => 'select', 'options' => "(SELECT 0 AS id, 'None' AS name) UNION (SELECT id, name FROM d_domains WHERE dataset_id = $cid ORDER BY name ASC)"),
				'attributes' => array('name' => 'Attributes', 'default' => '1:1:1:1:1:1', 'force' => true),
				'effects' => array('name' => 'Effects', 'type' => 'multi', 'sqllink' => 'd_profiles_links',
					'sqllinkdata' => array('profile_id' => '[ID]', 'link' => '[LINK]', 'type' => 'effect'), 'sqllinknums' => 'num',
					'hide' => true, 'multitextselects' => 1, 'multitexthtml' => "<select name=\"[NAME]\">$effectopts</select>"),
				'specials' => array('name' => 'Specials', 'type' => 'multi', 'sqllink' => 'd_profiles_links',
					'sqllinkdata' => array('profile_id' => '[ID]', 'link' => '[LINK]', 'type' => 'special'), 'sqllinknums' => 'num',
					'hide' => true, 'multitextselects' => 1, 'multitexthtml' => "<select name=\"[NAME]\">$specialopts</select>")
			);
			break;
	}

	if (isset($edit) && count($edit->relations))
	{
		CreateSqlEdit($edit);
	}
}

?>